
package net.mcreator.thefixedscript.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.animation.definitions.SnifferAnimation;

import net.mcreator.thefixedscript.entity.CircuitEntity;
import net.mcreator.thefixedscript.client.model.Modelcircuit;

public class CircuitRenderer extends MobRenderer<CircuitEntity, LivingEntityRenderState, Modelcircuit> {
	private CircuitEntity entity = null;

	public CircuitRenderer(EntityRendererProvider.Context context) {
		super(context, new AnimatedModel(context.bakeLayer(Modelcircuit.LAYER_LOCATION)), 0.5f);
	}

	@Override
	public LivingEntityRenderState createRenderState() {
		return new LivingEntityRenderState();
	}

	@Override
	public void extractRenderState(CircuitEntity entity, LivingEntityRenderState state, float partialTicks) {
		super.extractRenderState(entity, state, partialTicks);
		this.entity = entity;
		if (this.model instanceof AnimatedModel) {
			((AnimatedModel) this.model).setEntity(entity);
		}
	}

	@Override
	public ResourceLocation getTextureLocation(LivingEntityRenderState state) {
		return ResourceLocation.parse("the_fixed_script:textures/entities/circuit.png");
	}

	private static final class AnimatedModel extends Modelcircuit {
		private CircuitEntity entity = null;

		public AnimatedModel(ModelPart root) {
			super(root);
		}

		public void setEntity(CircuitEntity entity) {
			this.entity = entity;
		}

		@Override
		public void setupAnim(LivingEntityRenderState state) {
			this.root().getAllParts().forEach(ModelPart::resetPose);
			this.animateWalk(SnifferAnimation.SNIFFER_WALK, state.walkAnimationPos, state.walkAnimationSpeed, 1f, 1.1f);
			super.setupAnim(state);
		}
	}
}
